var Configuration;
var moment;
var getLocalVar;
var Util;
var angular;
let messages = {
    errosApuracao: "Erros na Apuração",
    timeout: "Tempo limite de conexão excedido."
};
var dadosInconsistencia = {};

function opl00900_listagem_de_corteController(General, Utilities, RestEngine, ScreenService, MessageService, templateManager, maskEngine, ZhUtil, ZHPromise){

    this.startScreen = function(widget) {
        widget.newRow();
        this.setFilterInitValues(widget);
    };
    
    this.setFilterInitValues = function(widget){
	    widget.currentRow.L_PER_LEV_PREV_CONS = {};
	    widget.currentRow.L_PER_LEV_PREV_CONS.formattedStart = moment().format('L');
        widget.currentRow.L_PER_LEV_PREV_CONS.formattedEnd = moment().format('L');
	    widget.currentRow.L_PER_LEV_PREV_CONS.start = moment().format('L');
        widget.currentRow.L_PER_LEV_PREV_CONS.end = moment().format('L');
        
	    widget.currentRow.L_PER_LEV_AF = {};
	    widget.currentRow.L_PER_LEV_AF.formattedStart = moment().format('L');
        widget.currentRow.L_PER_LEV_AF.formattedEnd = moment().format('L');
	    widget.currentRow.L_PER_LEV_AF.start = moment().format('L');
        widget.currentRow.L_PER_LEV_AF.end = moment().format('L');
    };
    
    this.selectUnidades = function(widget) {
        var regiao = (widget.currentRow.L_REGIAO.length >= 1) ? widget.currentRow.L_REGIAO.join('_') :  'T';
        var filterName = regiao === 'T' ? "P_TCDREGIAO" : "P_CDREGIAO";
        widget.getField('L_FILIAL').dataSource.name = "opl_relatorios#/crud/opl00900_filial_regiao";
        widget.getField('L_FILIAL').dataSourceFilter = [
            {
                "name": filterName,
                "operator": "=",
                "value": regiao
            }
        ];
        
        widget.getField('L_FILIAL').reload();
        this.setNGeracaoNull(widget);
    };
    
    this.setUnidadesNull = function(widget){
        widget.getField('L_FILIAL').clearValue();
    };
    
    this.selectNGeracao = function(widget) {
        if(widget.currentRow.L_FILIAL) {
            var filial = widget.currentRow.CDFILIAL;
            widget.getField('NR_GERACAO').dataSource.name = "opl_relatorios#/crud/opl00900_nr_geracao";
            widget.getField('NR_GERACAO').dataSourceFilter = [
                {
                    "name": "P_CDFILIOPELOG",
                    "operator": "=",
                    "value": filial
                }
            ];
            widget.getField('NR_GERACAO').reload();
        } else {
            this.setNGeracaoNull(widget);
            this.setUnidadesNull(widget);
            MessageService.showMessageByCode("L_FILIAL_VAZIA");
        }
    };
    
    this.setNGeracaoNull = function(widget) {
        widget.getField('NR_GERACAO').clearValue();
    };
    
    this.verificaNGeracao = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var filialIsSet = this.fieldIsSet(row.L_FILIAL);
        if(!filialIsSet) {
			widget.currentRow.NR_GERACAO = '';
			widget.currentRow.CDFILIAL = '';
			if(widget.name === "opl00900") {
                widget.getField('NR_GERACAO').readOnly = true;
                widget.getField('NR_GERACAO').readOnlyOnEdit = true;
                this.setNGeracaoNull(widget);
			}
        } else if(widget.name === "opl00900") {
            widget.getField('NR_GERACAO').readOnly = false;
            widget.getField('NR_GERACAO').readOnlyOnEdit = false;
            this.setNGeracaoNull(widget);
        }
    };

	this.fieldIsSet = function(fieldValue) {
		if (fieldValue) return true;
		else return false;
	};
	
	this.filterProdIni = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		if(!prodIniIsSet) {
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.CDPRODFIN = '';
		}

        this.checkProductRange(args.owner.field);
	};
	
	this.filterProdFin = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodFinIsSet = this.fieldIsSet(row.CDPRODFIN);
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		if (prodFinIsSet) {
			if (row.CDPRODINI > row.CDPRODFIN) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		} 
		this.checkProductRange(args.owner.field);
	};
	
	this.checkProductRange = function(field) {
	   var currentRow = field.widget.currentRow;
		if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
			var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;
			if (!this.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
				currentRow[field.outData[field.descriptionField]] = null;
				currentRow[field.outData[field.valueField]] = null;
                field.widget.getField('NMPRODINI').clearValue();
                field.widget.getField('NMPRODFIN').clearValue();
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		}
	};
	
	this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
        var mask = {
          type: "fix",
          params: {
              mask: mascara
          }
        };
        pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
        pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
        var nvinicial = pinicial.length;
        var nvfinal = pfinal.length;
        var resultado = true;
        if(nvinicial != nvfinal) {
            if(nvinicial > nvfinal) {
                resultado = false;
            }
        } else {
            var i = 0;
            do {
                if(pinicial[i] > pfinal[i]) {
                    resultado = false;
                }
                i++;
            }
            while (i<pinicial.length && resultado);
        }
        return resultado;
    };
    
    this.changeFieldsFromForm = function(widget) {
        if (widget.getField('NR_GERACAO').value().length >= 1) {
            //Clear values
            widget.getField('L_PER_LEV_PREV_CONS').clearValue();
            widget.getField('L_PER_LEV_AF').clearValue();
            widget.getField('L_COMPRADOR').clearValue();
            widget.getField('L_REGIAO').clearValue();
            widget.getField('NMPRODINI').clearValue();
            widget.getField('NMPRODFIN').clearValue();
            //Set ReadOnly fields
            widget.getField('L_PER_LEV_PREV_CONS').readOnly = true;
            widget.getField('L_PER_LEV_AF').readOnly = true;
            widget.getField('L_COMPRADOR').readOnly = true;
            widget.getField('L_REGIAO').readOnly = true;
            widget.getField('NMPRODINI').readOnly = true;
            widget.getField('NMPRODFIN').readOnly = true;
            //Delete validations of fields
            delete widget.getField('L_COMPRADOR').validations.required;
            delete widget.getField('NMPRODINI').validations.required;
            delete widget.getField('NMPRODFIN').validations.required;
        } else {
            //Alter ReadOnly fields
            widget.getField('L_PER_LEV_PREV_CONS').readOnly = false;
            widget.getField('L_PER_LEV_AF').readOnly = false;
            widget.getField('L_COMPRADOR').readOnly = false;
            widget.getField('L_REGIAO').readOnly = false;
            widget.getField('NMPRODINI').readOnly = false;
            widget.getField('NMPRODFIN').readOnly = false;
            //Alter validations of fields
            widget.getField('L_COMPRADOR').validations.required = true;
            widget.getField('NMPRODINI').validations.required = true;
            widget.getField('NMPRODFIN').validations.required = true;
            this.setFilterInitValues(widget);
        }
    };
    
    this.verificaRelatorio = function(widget) {
        var currentRow = widget.currentRow;
        console.log(widget);
        if(widget.isValid()) {
            var reportName = currentRow.REPORT_NAME.split('.')[0];
            General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow, reportName]);
        }
    };
    
    //Verifica o formulário e valida o COMPRADOR
    this.verificaFormForCalculo = function(widget) {
        if(widget.isValid()) {
            this.openLoginValidation(widget);
        }
    };
    
    this.abreRelatorio = function(widget, currentRow, reportName) {
        var row = angular.copy(currentRow);
        row.P_CDFILIALOL = row.CDFILIAL;
        if (row.NR_GERACAO) {
            row.P_NRLOGCORTEOL = row.NR_GERACAO;
        } else {
            row.P_NRLOGCORTEOL = '';
        }
        row.P_DTINICIAL = row.L_PER_LEV_PREV_CONS.start;
        row.P_DTFINAL = row.L_PER_LEV_PREV_CONS.end;
        row.P_DTINICIALAF = row.L_PER_LEV_AF.start;
        row.P_DTFINALAF = row.L_PER_LEV_AF.end;
        row.P_CDREGIAO = row.L_REGIAO ? Array.isArray(row.L_REGIAO) && row.L_REGIAO.length > 0 ? row.L_REGIAO.join('_') : 'T' : 'T';
        row.P_CDOPERADOR = row.L_COMPRADOR ? Array.isArray(row.L_COMPRADOR) && row.L_COMPRADOR.length > 0 ? row.L_COMPRADOR.join('_') : 'T' : 'T';
        row.P_CDPRODINIC = row.CDPRODINI;
        if(row.CDPRODFIN) {
            let concatString = row.CDPRODFIN.concat('ZZZZZZZZZZZZZZZZZZZZ');
            row.P_CDPRODFIN = concatString.substring(0, 20);
        } else {
            row.P_CDPRODFIN = 'ZZZZZZZZZZZZZZZZZZZZ';
        }
        row.P_GERACMP = 'N';
        row.P_ANALITICO = row.ANALITICO;
        row.STRATEGY = row.REPORT_NAME.split('.')[1];
        row.NRORG = getLocalVar('NRORG');
        row.reportLabel = '';
        General.openReport("opl_relatorios#/opl00900_relatorio", reportName, row).then(success => {}).catch(error => {
            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
        });
    };
    
    //Abre o form para Login
    this.openLoginValidation = function(widget) {
        var DTINICIAL = widget.currentRow.L_PER_LEV_PREV_CONS.start;
        var DTFINAL = widget.currentRow.L_PER_LEV_PREV_CONS.end;
        var DTINICIALAF = widget.currentRow.L_PER_LEV_AF.start;
        var DTFINALAF = widget.currentRow.L_PER_LEV_AF.end;
        if(DTINICIAL != "" && DTFINAL != "" && widget.currentRow.L_COMPRADOR != "" || DTINICIALAF != "" && DTFINALAF != "" && widget.currentRow.L_COMPRADOR != "") {
            if (widget.currentRow.L_COMPRADOR.length === 1) {
                General.callRestEngine("opl_relatorios#/compValidation", "Row", {
                    "CDCOMPRADOR": widget.currentRow.L_COMPRADOR[0],
                    "CDOPERADOR": getLocalVar('CDOPERADOR'),
                    "CDCENTCMP": getLocalVar('CDFILIAL')
                }).then(function(response) {
                    if (response.dataset.passwordAut.PARAM === 'S') {
                        widget.container.getWidget('LOGIN').currentRow.CDCOMPRADOR = widget.currentRow.L_COMPRADOR[0];
                        widget.container.getWidget('LOGIN').currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
                        ScreenService.openPopup(widget.container.getWidget('LOGIN'));
                    } else if(response.dataset.passwordAut.PARAM === 'N') {
                        ScreenService.showMessage('Operador não autorizado a realizar apuração para o comprador.', 'error', 'error');
                    }
                }).catch(function(error) {
                    ScreenService.showMessage(error.data ? error.data.error : messages.timeout, 'error', 'error');
                    widget.currentRow.CDCOMPRADOR = "";
                });
            } else {
                ScreenService.showMessage('Deve ser informado apenas 1 comprador.', 'error', 'error');
            }
        } else {
            if(widget.currentRow.L_COMPRADOR == ""){
                ScreenService.showMessage('Informe um Comprador.', 'error', 'error');
            } else if (DTINICIAL == "" && DTFINAL == "" || DTINICIALAF == "" && DTFINALAF == "") {
                ScreenService.showMessage('Informe um Periodo de Levantamento.', 'error', 'error');
            }
        }
    };

    //Valida o Login
    this.loginValidation = function(widget) {
        if(!Util.isEmptyOrBlank(widget.currentRow.PASSWORD)){
            General.callRestEngine("opl_relatorios#/passwordValidation", "Row", widget.currentRow).then(function(response) {
                widget.currentRow = {};
                ScreenService.closePopup();
                //Chama a procedure 
                procedureCalcular();
            }).catch(function(error) {
                ScreenService.showMessage(error.data.error);
                widget.currentRow.PASSWORD = "";
            });
        } else {
            ScreenService.showMessage('Senha deve ser informada.', 'exclamation', 'exclamation');
        }
    };
    
    //Executa procedure 
    var procedureCalcular = function() {
        var widget = templateManager.container.getWidget('opl00900');
        ScreenService.showLoader();
        General.callRestEngine("opl_relatorios#/getGeraCorteOL", "Row", {
            "P_CDFILIOPELOG": widget.currentRow.CDFILIAL,
            "P_CDFILLANC": widget.currentRow.CDFILIAL,
            "P_CDOPERLANC": getLocalVar('CDOPERADOR'),
            "P_DTINICIAL": widget.currentRow.L_PER_LEV_PREV_CONS,
            "P_DTFINAL": widget.currentRow.L_PER_LEV_PREV_CONS,
            "P_DTINICIALAF": widget.currentRow.L_PER_LEV_AF,
            "P_DTFINALAF": widget.currentRow.L_PER_LEV_AF,
            "P_TIPOCONSULTA": '',
            "P_COMPRADOR": widget.currentRow.L_COMPRADOR[0],
            "P_CDREGIAO": widget.currentRow.L_REGIAO ? Array.isArray(widget.currentRow) && widget.currentRow.L_REGIAO.length > 0 ? widget.currentRow.L_REGIAO.join('_') : 'T' : 'T',
            "P_CDPRODINIC": widget.currentRow.CDPRODINI,
            "P_CDPRODFIN": (widget.currentRow.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20),
            "P_DTPROCESSA": getLocalVar('DTPROCESSA')
        }).then(function(response) {
            //Armazena o result
            response = response.dataset.result[0];
            if (response === "NN") {
                ScreenService.showMessage('Não há dados para apuração/efetivação do OL.', 'error', 'error');
                //Abre a tela de apuração/Efet... OL
                openWindowApuracaoEfetivacaoOL();
            } else {
                if (response.substr(12,1) === "N") {
                    ScreenService.showMessage('Não há dados para verificação de inconsistência do OL, favor verificar se já existe AF para o período informado.', 'error', 'error');
                    //Abre a tela de apuração/Efet... OL
                    openWindowApuracaoEfetivacaoOL();
                } else {
                    //Abre popup com pergunta, caso SIM, cria relatório de inconsistencia
                    ScreenService.confirmMessage('Deseja verificar se existe inconsitências na Apuração/Efetivação do OL?', 'question', (success) =>  {
                        //Armazena os dados na aray de inconsistencia
                        dadosInconsistencia.P_CDFILIALOL = widget.currentRow.CDFILIAL;
                        dadosInconsistencia.P_CDOPERADOR = widget.currentRow.L_COMPRADOR[0];
                        dadosInconsistencia.P_CDFILCENTCMP = '';
                        dadosInconsistencia.P_NRAPURPREC = '';
                        if(widget.currentRow.L_PER_LEV_PREV_CONS.start !== ''){
                            dadosInconsistencia.P_DTINICIAL = widget.currentRow.L_PER_LEV_PREV_CONS.start;
                        } else if (widget.currentRow.L_PER_LEV_AF.start !== ''){
                            dadosInconsistencia.P_DTINICIAL = widget.currentRow.L_PER_LEV_AF.start;
                        } else {
                            dadosInconsistencia.P_DTINICIAL = '';
                        }
                        if(widget.currentRow.L_PER_LEV_PREV_CONS.end !== ''){
                            dadosInconsistencia.P_DTFINAL = widget.currentRow.L_PER_LEV_PREV_CONS.end;
                        } else if (widget.currentRow.L_PER_LEV_AF.end !== ''){
                            dadosInconsistencia.P_DTFINAL = widget.currentRow.L_PER_LEV_AF.end;
                        } else {
                            dadosInconsistencia.P_DTFINAL = '';
                        }
                        dadosInconsistencia.P_NRLOGCORTEOL = response.substr(1, 9);
                        widget.container.getWidget('opl00900').reload();
                        widget.container.getWidget('gridInconsistencia').reload();
                        ScreenService.openPopup(widget.container.getWidget('gridInconsistencia'));
                    }, function(error) {
                        //Se cliclou em NÃO
                        if(error.cancelable === true){
                            //Abre a tela de apuração/Efet... OL
                            openWindowApuracaoEfetivacaoOL();
                        } else {
                            ScreenService.errorNotification(error, 'ERROR');
                        }
                    });

                }
            }
            //Se tem response OU se o result é maior que 12(em caracters) e a posição 12 da string é = "N"
            if (!response || response.length >= 13 && response.substr(11,1) === "N") {
                ScreenService.showMessage('Não há dados para apuração/efetivação do OL.', 'error', 'error');
                //Abre a tela de apuração/Efet... OL
                openWindowApuracaoEfetivacaoOL();
            }
        }).catch(function(error) {
            ScreenService.showMessage('Ocorreu um erro ao calcular.', 'error', 'error');
        });
        ScreenService.hideLoader();
    };
    
    //Monta o filtro do datasouce do grid de insconsistencia
    this.setDataSourceFilter = function(){
        var widgetInconsistencia = templateManager.container.getWidget('gridInconsistencia');
        var widgetOpl00900 = templateManager.container.getWidget('opl00900');
        widgetInconsistencia.dataSourceFilter = [
	        {
	            "name": "P_CDFILIALOL",
		        "operator": "=",
		        "value": dadosInconsistencia.P_CDFILIALOL
		    },
		    {
		        "name": "P_CDOPERADOR",
		        "operator": "=",
		        "value": dadosInconsistencia.P_CDOPERADOR
		    },
		    {
		        "name": "P_CDFILCENTCMP",
		        "operator": "=",
		        "value": dadosInconsistencia.P_CDFILCENTCMP
		    },
		    {
		        "name": "P_NRAPURPREC",
		        "operator": "=",
		        "value": dadosInconsistencia.P_NRAPURPREC
		    },
		    {
		        "name": "P_DTINICIAL",
		        "operator": "=",
		        "value": dadosInconsistencia.P_DTINICIAL
		    },
		    {
		        "name": "P_DTFINAL",
		        "operator": "=",
		        "value": dadosInconsistencia.P_DTFINAL
		    },
		    {
		        "name": "P_NRLOGCORTEOL",
		        "operator": "=",
		        "value": dadosInconsistencia.P_NRLOGCORTEOL
		    }
	    ];
	    widgetInconsistencia.reload();
	    widgetOpl00900.reload();
    };
    
    //Seta a label do popup Relatório de Insonsistência
    this.setLabel = function(){
        var widgetOpl00900 = templateManager.container.getWidget('opl00900');
        var widgetInconsistencia = templateManager.container.getWidget('gridInconsistencia');
        setTimeout(() => {
            ScreenService.showLoader();
	        var data = widgetInconsistencia.groupedData[0];
            var label = '<center>Relatorio de inconsistência</center><br><font size = "2px"> Unidade OL: __CDFILIALOL__ - __NMFILIALOL__ <br>' + `Periodo Considerando Consumo: ` + widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.formattedStart + ` até ` + widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.formattedEnd + ` | ` + `Periodo Considerando AF: ` + widgetOpl00900.currentRow.L_PER_LEV_AF.formattedStart + ` até ` + widgetOpl00900.currentRow.L_PER_LEV_AF.formattedEnd + `<br>Compador: __CDOPERADOR__ - __NMOPERADOR__` + '<br> Legenda:' + '<br><pre><font size = "1px">  NC - Item não cotado                                                                              AND - Cotação em andamentoo                                                                PNR - Produto não Relacionado<br>' +  '  QM - Qualificação de marca                                                                   FNF - Fornecedor não atende a filial <br>' + '  QF - Qualificação de fornecedor                                                            QPF - Qualificação de produto por fornecedor <br>' + '  AF - Existe AF do OL para o período filtrado                                         FSI - Fornecedor com Situação Inativa <br>' + '  PC - Produto não cadastrado para o comprador                                 TFA - Tipo de Fornecedor Alternativo <br>' +  '  MP - Marca Padrão diferente da Marca da AF                                      PCF - Produto deve ser Comprado pela Filial</pre>';
            if(data !== undefined) {
                if(data.CDFILIALOL){
                   label = label.replace("__CDFILIALOL__", data.CDFILIALOL);  
                }
                if(data.NMFILIALOL){
                   label = label.replace("__NMFILIALOL__", data.NMFILIALOL);  
                }
                if(data.CDOPERADOR){
                   label = label.replace("__CDOPERADOR__", data.CDOPERADOR);  
                }
                if(data.NMOPERADOR){
                   label = label.replace("__NMOPERADOR__", data.NMOPERADOR);  
                }
            } else {
                label = label.replace("__CDFILIALOL__", '');  
                label = label.replace("__NMFILIALOL__", '');  
                label = label.replace("__CDOPERADOR__", '');  
                label = label.replace("__NMOPERADOR__", '');  
            }
            widgetInconsistencia.label = label;
            widgetInconsistencia.redraw();
            ScreenService.hideLoader();
        }, 1500);
    };
    
    //Chama a função que abre a tela de apuração;efetivação
    this.callFunctionOpenWindowApuracaoEfetivacaoOL = function() {
        openWindowApuracaoEfetivacaoOL();  
    };
    
    //Abre a tela de Apuração Efetivação do OL
    var openWindowApuracaoEfetivacaoOL = function (){
        var widgetOpl00900 = templateManager.container.getWidget('opl00900');
        var widgetInconsistencia = templateManager.container.getWidget('gridInconsistencia');
        var currentRowWidgetInconsistencia = widgetInconsistencia.dataSource.data[0];
        //Abre a tela de apuração/Efet... OL
        ScreenService.openWindow('opl#apuracao_efetivacao').then(function(){
            var widgetOldCot = templateManager.container.getWidget('widgetOldCot');
            widgetOldCot.dataSourceFilter.CDCENTCMP = getLocalVar('CDFILCENTCMP');
			widgetOldCot.dataSourceFilter.NMCENTCMP = getLocalVar('NMFILCENTCMP');
			widgetOldCot.dataSourceFilter.CDCOMPRADOR = widgetOpl00900.currentRow.L_COMPRADOR[0];
			widgetOldCot.dataSourceFilter.DTENTREGA = currentRowWidgetInconsistencia.CDFILIALOL;
			widgetOldCot.dataSourceFilter.CDREGIAO = widgetOpl00900.currentRow.CDREGIAO;
			widgetOldCot.dataSourceFilter.CDGRUPFILI = currentRowWidgetInconsistencia.CDFILIALOL;
			widgetOldCot.dataSourceFilter.LISTAFILIAL = currentRowWidgetInconsistencia.CDFILIALOL;
			widgetOldCot.dataSourceFilter.TODOS_PRODUTOS = 'S';
			widgetOldCot.dataSourceFilter.PRODUTOINI = widgetOpl00900.currentRow.NMPRODINI;
			widgetOldCot.dataSourceFilter.PRODUTOFIN = widgetOpl00900.currentRow.NMPRODFIN;
			widgetOldCot.dataSourceFilter.EXTRA = 'N';
            widgetOldCot.reload().then(function() {
			    widgetOldCot.activate();
			    widgetOldCot.redraw();
	    	});
        });

    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register("opl00900_listagem_de_corteController", opl00900_listagem_de_corteController);
});

